


 
// by TheYinas
//

// define globals
var isMetric = true
var showMenu = false
var colorunselected = rgba(255,255,255,255)
var colorselected = rgba(244,244,244,255)

var sysinfoStates = [0,1,3,4]
var infostatescount = 9  // actual count of states available
var sysinfoLabels = [ "HDD:",              //0
                      "CPU Temp:",         //1
                      "CPU Usage:",        //2
                      "Uptime:",           //3
                      "Up/Down:",          //4
                      "RAM Usage:",        //5
                      "Bin Usage:",        //6
                      "Battery:",          //7
                      "Volume:" ]          //8
                      
var sysinfoCores = [ m_diskcoretotal,      //0
                     coretempcore1,        //1
                     cpucore1,             //2
                     datetimecore1,        //3
                     netmonitorcore1,      //4
                     ramcore1,             //5
                     recyclebincore1,      //6
                     batterycore1,         //7
                     volumecore1 ]         //8

var sysinfoCoreFormats = [ "%AllUsedG/%AllTotalG GB",             //0
                           "%CPUTemp",                           //1
                           "%Percent%",                           //2
                           "${UpTimeD}d${UpTimeH}h${UpTimeM}m",   //3
                           "%NetOutSpeedK / %NetInSpeedK Kb",     //4
                           "%PhysPercent%",                       //5
                           "%SizeM Mb",                           //6
                           "${Percent}%",                         //7
                           "%Volume%" ]                           //8
                           
var sysinfoCircleStates = [ 1 ]
var circleinfostatescount = 5   // actual count of states available to circle display
var sysinfoCircleLabels = [ "HDD",        //0
                            "CPU",        //1
                            "RAM",        //2
                            "Batt",       //3
                            "Vol" ]       //4
                      
var sysinfoCircleCores =  [ m_diskcoretotal,      //0
                            cpucore1,             //1
                            ramcore1,             //2
                            batterycore1,         //3
                            volumecore1 ]         //4
                     
var sysinfoCircleCoreFormats = [ "%Percent",     //0
                                 "%Percent",     //1
                                 "%PhysPercent", //2
                                 "${Percent}",   //3
                                 "%Volume" ]     //4
                           
// 4 lines available
/* states correspond as follows:
     0... HDD space used relative to max
     1... CPU usage
     2... RAM usage
     3... Battery state %
     4... Sys Volume %
 */
 
function widgetOnLoad()
{ 
//  widget.WindowZPosition = 2 (keep topmost) / 1 (topmost) / 0 (normal) / -1 (bottom)
  widget.WindowZPosition = -1;
  
  // default clock is 24h
  timeSetTo24hr()
      
  // default units are metric
  isMetric = true
  setUnits()
              
  // popup menu not shown on load
  showElements()
}


function menuitem11OnClick(Sender)
{
  isMetric = true
  setUnits()                          
}

function menuitem12OnClick(Sender)
{
  isMetric = false
  setUnits()
}

function menuitem5OnClick(Sender)
{
  timeSetTo12hr()
}

function menuitem9OnClick(Sender)
{
  timeSetTo24hr()
}

function datetimecore1OnUpdate(Sender)
{
  if (datetimecore1.get("%is12hr") == "true")
  {
    menuitem5.Visible=false
    menuitem9.Visible=true
    popmenu_item1_12.Visible=false
    popmenu_item1_24.Visible=true
  }
  else
  {
    menuitem5.Visible=true
    menuitem9.Visible=false
    popmenu_item1_12.Visible=true
    popmenu_item1_24.Visible=false
  }
}
      
function setUnits()
{
  if (isMetric == true)
  {
    accweathercore1.cmd(null,"!SetMetric")
    coretempcore1.cmd(null,"!SetTempUnitCelcius")
  }
  else
  {
    accweathercore1.cmd(null,"!SetImperial")
    coretempcore1.cmd(null,"!SetTempUnitFahrenheit")
  }
}
             
function accweathercore1OnUpdate(Sender)
{
  if (isMetric == true)
  {
    showImperialMenus()
  }
  else
  {
     showMetricMenus()
  }
}

function coretempcore1OnUpdate(Sender)
{
  if (isMetric == true)
  {
    showImperialMenus()
  }
  else
  {
    showMetricMenus()
  }  
}



function timeSetTo12hr()
{
  datetimecore1.cmd(null,"!12hr")
}

function timeSetTo24hr()
{
  datetimecore1.cmd(null,"!24hr")
}

function popmenu_item1OnClick(Sender)
{
    if (datetimecore1.get("%is12hr") == "true")
    {
      timeSetTo24hr()
    }  
    else
    {
      timeSetTo12hr()
    }
}


function popmenu_itemOnMouseEnter(Sender)
{
  Sender.background.solidColor.color = colorselected
}

function popmenu_itemOnMouseLeave(Sender)
{
  Sender.background.solidColor.color = colorunselected
}


function button_menuOnClick(Sender)
{
  if (slide_menu.Slided)
  {
    hideElements()
  }
  else
  {
    showElements()
  }
  slide_menu.Slided = !slide_menu.Slided
}


function hideElements()
{
  widget.cmd("!FadeOutVisibleObj=layer_modules")
  widget.cmd("!FadeOutVisibleObj=layer_clock")
  back_button.Visible=true
  widget.cmd("!FadeInVisibleObj=layer_menuheader")
}

function showElements()
{
  widget.cmd("!FadeInVisibleObj=layer_modules")
  widget.cmd("!FadeInVisibleObj=layer_clock")
  back_button.Visible=false
  widget.cmd("!FadeOutVisibleObj=layer_menuheader")
}

function popmenu_item2OnClickImp(Sender)
{
  isMetric = false
  setUnits()  
}

function popmenu_item2OnClickMet(Sender)
{
  isMetric = true
  setUnits()
}

function showMetricMenus()
{
    menuitem11.Visible=true
    menuitem12.Visible=false
    popmenu_item2_imp.Visible=false
    popmenu_item2_met.Visible=true
}

function showImperialMenus()
{
    menuitem11.Visible=false
    menuitem12.Visible=true
    popmenu_item2_imp.Visible=true
    popmenu_item2_met.Visible=false
}


function back_buttonOnClick(Sender)
{
  button_menuOnClick(Sender)
}

function hintboxUpdate(Sender)
{
   hintbox.Text=Sender.TagString
}

function hintboxClear(Sender)
{
   hintbox.Text=""
}

function temperatureUnitToggle()
{
  if (isMetric == true)
  {
    isMetric = false
  }
  else
  {
    isMetric = true
  }
  setUnits()
}



function sysinfoOnClick(Sender)
{
  if ( (sysinfoStates[Sender.Tag-1] += 1) >= infostatescount)
  {
    sysinfoStates[Sender.Tag-1] = 0
  }
  sysinfoUpdate(Sender)
}

function sysinfoUpdate(Sender)
{
  var tlabel = eval("label_sysinfo_" + (Sender.Tag))
  var tdata = eval("data_sysinfo_" + (Sender.Tag))
  var istate = eval(sysinfoStates[Sender.Tag-1])
  
  // redundant, but better safe than sorry
  if (istate >= infostatescount)
  {
    istate = 0
  }
  
  //label
  tlabel.Text = sysinfoLabels[istate]
          
  //data
  tdata.Text = sysinfoLabels[istate]
  tdata.Core = sysinfoCores[istate]
  tdata.Coreformat = sysinfoCoreFormats[istate]
}

function sysinfoCircleOnClick(Sender)
{
  if ( (sysinfoCircleStates[Sender.Tag-1] += 1) >= circleinfostatescount)
  {
    sysinfoCircleStates[Sender.Tag-1] = 0
  }
  sysinfoCircleUpdate(Sender)
}

function sysinfoCircleUpdate(Sender)
{
  var tclabel = eval("cl_sysinfo_" + (Sender.Tag))
  var tcdata = eval("cd_sysinfo_" + (Sender.Tag))
  var tcvalue = eval("cv_sysinfo_" + (Sender.Tag))
  var icstate = eval(sysinfoCircleStates[Sender.Tag-1])
    
  // redundant, but better safe than sorry
  if (icstate >= circleinfostatescount)
  {
    icstate = 0
  }

  //label
  tclabel.Text = sysinfoCircleLabels[icstate]
   
  //data
  tcdata.Text = sysinfoCircleLabels[icstate]
  tcdata.Core = sysinfoCircleCores[icstate]
  tcdata.Coreformat = sysinfoCircleCoreFormats[icstate]
  
  //circle value
  tcvalue.Core = sysinfoCircleCores[icstate]
  tcvalue.Coreformat = sysinfoCircleCoreFormats[icstate]
}
